<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'store';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/store/'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 门店列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['store']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['store_add'],
            'href' => 'store.php?rec=add' 
    ));
    
    // 获取参数
    $class = !$check->is_illegal_char($_REQUEST['class']) ? $_REQUEST['class'] : '';
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
 
    $where = $class ? " AND class = '$class'" : ''; // 分组
    if ($keyword) {
        $where = $where . " AND name LIKE '%$keyword%'";
        $get = '&keyword=' . $keyword;
    }
 
    // 把第一个AND替换成WHERE
    $where = $dou->where($where);
 
    // 排序
    $sort = $_OPEN['sort'] ? "sort ASC, " : '';
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('store') . $where . " ORDER BY " . $sort . "id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $page_url = 'store.php' . ($class ? '?class=' . $class : '');
    $limit = $dou->pager($sql, 15, $page, $page_url, $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $add_time = date("Y-m-d", $row['add_time']);
        
        $store_list[] = array (
                "id" => $row['id'],
                "name" => $row['name'],
                "class" => $row['class'],
                "address" => $row['address'],
                "telphone" => $row['telphone'],
                "image" => $dou->dou_file($row['image']),
                "sort" => $row['sort'],
                "add_time" => $add_time 
        );
    }
    
    // 赋值给模板
    $smarty->assign('keyword', $keyword);
    $smarty->assign('class_list', $dou->get_no_repeat_value('store', 'class', $class));
    $smarty->assign('store_list', $store_list);
    
    $smarty->display('store.htm');
} 

/**
 * +----------------------------------------------------------
 * 门店添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['store_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['store'],
            'href' => 'store.php' 
    ));
    
    // 格式化自定义参数，并存到数组$store，门店编辑页面中调用门店详情也是用数组$store，
    if ($_DEFINED['store']) {
        $defined = explode(',', $_DEFINED['store']);
        foreach ($defined as $row) {
            $defined_store .= $row . "：\n";
        }
        $store['defined'] = trim($defined_store);
        $store['defined_count'] = count(explode("\n", $store['defined'])) * 2;
    }
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('class_list', $dou->get_no_repeat_value('store', 'class'));
    $smarty->assign('item_id', $dou->auto_id('store'));
    $smarty->assign('store', $store);
    
    $smarty->display('store.htm');
} 

elseif ($rec == 'insert') {
    // 验证标题
    if (empty($_POST['name'])) $dou->dou_msg($_LANG['store_name'] . $_LANG['is_empty']);
    
    // 文件上传盒子
    $image = $file->box('store', $dou->auto_id('store'), 'image', 'main');

    // 数据格式化
    $add_time = time();
    $_POST['defined'] = str_replace("\r\n", ',', $_POST['defined']);
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "INSERT INTO " . $dou->table('store') . " (id, name, `class`, address, telphone, defined, content, image ,keywords, description, sort, add_time)" . " VALUES (NULL, '$_POST[name]', '$_POST[class]', '$_POST[address]', '$_POST[telphone]', '$_POST[defined]', '$_POST[content]', '$image', '$_POST[keywords]', '$_POST[description]', '$_POST[sort]', '$add_time')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['store_add'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['store_add_succes'], 'store.php');
} 

/**
 * +----------------------------------------------------------
 * 门店编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['store_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['store'],
            'href' => 'store.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $store = $dou->get_row('store', '*', "id = '$id'");
    
    // 格式化数据
    $store['image'] = $dou->dou_file($store['image']);
    
    // 格式化自定义参数
    if ($_DEFINED['store'] || $store['defined']) {
        $defined = explode(',', $_DEFINED['store']);
        foreach ($defined as $row) {
            $defined_store .= $row . "：\n";
        }
        // 如果门店中已经写入自定义参数则调用已有的
        $store['defined'] = $store['defined'] ? str_replace(",", "\n", $store['defined']) : trim($defined_store);
        $store['defined_count'] = count(explode("\n", $store['defined'])) * 2;
    }
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('class_list', $dou->get_no_repeat_value('store', 'class', $store['class']));
    $smarty->assign('item_id', $id);
    $smarty->assign('item_content', $store['content']);
    $smarty->assign('store', $store);
    
    $smarty->display('store.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    // 验证标题
    if (empty($_POST['name'])) $dou->dou_msg($_LANG['store_name'] . $_LANG['is_empty']);
        
    // 文件上传盒子
    $image = $file->box('store', $id, 'image', 'main');
    $image = $image ? ", image = '" . $image . "'" : '';
    
    // 格式化自定义参数
    $_POST['defined'] = str_replace("\r\n", ',', $_POST['defined']);
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    $sql = "UPDATE " . $dou->table('store') . " SET name = '$_POST[name]', `class` = '$_POST[class]', address = '$_POST[address]', telphone = '$_POST[telphone]', defined = '$_POST[defined]', content = '$_POST[content]'" . $image . ", keywords = '$_POST[keywords]', description = '$_POST[description]', sort = '$_POST[sort]' WHERE id = '$id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['store_edit'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['store_edit_succes'], 'store.php');
}

/**
 * +----------------------------------------------------------
 * 门店删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'store.php');
    $name = $dou->get_one("SELECT name FROM " . $dou->table('store') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm'])) {
        // 删除相应商品图片
        $image = $dou->get_one("SELECT image FROM " . $dou->table('store') . " WHERE id = '$id'");
        $dou->del_file($image);
        
        $dou->create_admin_log($_LANG['store_del'] . ': ' . $name);
        $dou->delete('store', "id = $id", 'store.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'store.php', '', '30', "store.php?rec=del&id=$id");
    }
} 

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'del_all') {
            // 批量门店删除
            $dou->del_all('store', $_POST['checkbox'], 'id', 'image');
        } elseif ($_POST['action'] == 'category_move') {
            // 批量移动分类
            $dou->category_move('store', $_POST['checkbox'], $_POST['new_cat_id']);
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['store_select_empty']);
    }
}

/**
 * +----------------------------------------------------------
 * 首页显示筛选
 * +----------------------------------------------------------
 */
elseif ($rec == 'sort') {
    // act操作项的初始化
    $act = $check->is_rec($_REQUEST['act']) ? $_REQUEST['act'] : '';
 
    $dou->sort_box('store', $act, $id);
    $dou->dou_header($_SERVER['HTTP_REFERER']); // 跳转到上一页面
}

?>